<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2005 Larry Adams                                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0])) {
	die("<br><strong>This script is only meant to run at the command line.</strong>");
}

$no_http_headers = true;

include(dirname(__FILE__) . "/../../include/config.php");
include(dirname(__FILE__) . "/lib/mactrack_functions.php");

/* update first beta database to current standard */
print db_execute("ALTER TABLE `mac_track_devices` MODIFY COLUMN `snmp_timeout` INT(10) UNSIGNED NOT NULL DEFAULT 500;");
print db_execute("ALTER TABLE `mac_track_devices` MODIFY COLUMN `snmp_retries` TINYINT(11) UNSIGNED NOT NULL DEFAULT 3;");
print db_execute("ALTER TABLE `mac_track_ports` ADD COLUMN `dns_hostname` VARCHAR(200) DEFAULT '' AFTER `ip_address`;");
print db_execute("ALTER TABLE `mac_track_temp_ports` ADD COLUMN `dns_hostname` VARCHAR(200) DEFAULT '' AFTER `ip_address`;");
print db_execute("ALTER TABLE `mac_track_ips` ADD COLUMN `dns_hostname` VARCHAR(200) DEFAULT '' AFTER `ip_address`;");
print db_execute("ALTER TABLE `mac_track_devices` ADD COLUMN `snmp_port` INT(10) UNSIGNED NOT NULL DEFAULT '161' AFTER `snmp_version`;");
print db_execute("ALTER TABLE `mac_track_devices` ADD COLUMN `macs_active` INT(10) UNSIGNED NOT NULL DEFAULT '0' AFTER `ports_trunk`;");
print db_execute("ALTER TABLE `mac_track_devices` ADD COLUMN `snmp_sysName` VARCHAR(100) DEFAULT '' AFTER `snmp_retries`;");
print db_execute("ALTER TABLE `mac_track_devices` ADD COLUMN `snmp_sysLocation` VARCHAR(100) DEFAULT '' AFTER `snmp_sysName`;");
print db_execute("ALTER TABLE `mac_track_devices` ADD COLUMN `snmp_sysContact` VARCHAR(100) DEFAULT '' AFTER `snmp_sysLocation`;");
print db_execute("CREATE TABLE `mac_track_scanning_functions` (`scanning_function` VARCHAR(100) NOT NULL DEFAULT '', `description` VARCHAR(200) NOT NULL DEFAULT '', PRIMARY KEY(`scanning_function`));");
print db_execute("ALTER TABLE `mac_track_devices` DROP PRIMARY KEY, ADD PRIMARY KEY(`hostname`, `snmp_port`, `site_id`), ADD INDEX `device_id`(`device_id`);");
print db_execute("ALTER TABLE `mac_track_sites` ADD COLUMN `total_oper_ports` INT(10) UNSIGNED NOT NULL DEFAULT '0' AFTER `total_user_ports`;");
print db_execute("ALTER TABLE `mac_track_device_types` DROP PRIMARY KEY, ADD PRIMARY KEY(`sysDescr_match`, `sysObjectID_match`, `device_type`), ADD INDEX `device_type_id`(`device_type_id`);");
print db_execute("ALTER TABLE `mac_track_scanning_functions` MODIFY COLUMN `scanning_function` VARCHAR(100) NOT NULL DEFAULT '', MODIFY COLUMN `description` VARCHAR(200) NOT NULL DEFAULT '';");
print db_execute("CREATE TABLE `mac_track_scan_dates` (`scan_date` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00', PRIMARY KEY(`scan_date`));");
print db_execute("REPLACE INTO `mac_track_scan_dates` (SELECT DISTINCT scan_date from mac_track_ports);");
print db_execute("ALTER TABLE `mac_track_devices` ADD INDEX `snmp_sysDescr`(`snmp_sysDescr`), ADD INDEX `snmp_sysObjectID`(`snmp_sysObjectID`);");
print db_execute("ALTER TABLE `mac_track_devices` ADD COLUMN `device_type_id` INT(10) UNSIGNED DEFAULT 0 AFTER `device_id`;");
print db_execute("ALTER TABLE `mac_track_devices` ADD INDEX `device_type_id`(`device_type_id`);");
print db_execute("ALTER TABLE `mac_track_ports` ADD INDEX `port_name`(`port_name`);");
print db_execute("ALTER TABLE `mac_track_ports` ADD INDEX `dns_hostname`(`dns_hostname`);");
print db_execute("ALTER TABLE `mac_track_devices` MODIFY COLUMN `ips_total` INTEGER UNSIGNED NOT NULL DEFAULT 0");
print db_execute("ALTER TABLE `mac_track_devices` MODIFY COLUMN `vlans_total` INTEGER UNSIGNED NOT NULL DEFAULT 0");
print db_execute("ALTER TABLE `mac_track_devices` MODIFY COLUMN `ports_total` INTEGER UNSIGNED NOT NULL DEFAULT 0");
print db_execute("ALTER TABLE `mac_track_devices` MODIFY COLUMN `ports_active` INTEGER UNSIGNED NOT NULL DEFAULT 0");
print db_execute("ALTER TABLE `mac_track_devices` MODIFY COLUMN `ports_trunk` INTEGER UNSIGNED NOT NULL DEFAULT 0");
print db_execute("ALTER TABLE `mac_track_devices` MODIFY COLUMN `macs_active` INTEGER UNSIGNED NOT NULL DEFAULT 0");
print db_execute("ALTER TABLE `mac_track_temp_ports` ADD COLUMN `updated` TINYINT UNSIGNED NOT NULL DEFAULT 0 AFTER `scan_date`;");
print db_execute("ALTER TABLE `mac_track_temp_ports` ADD INDEX `updated`(`updated`);");
print db_execute("ALTER TABLE `mac_track_temp_ports` ADD INDEX `ip_address`(`ip_address`);");
print db_execute("CREATE TABLE `mac_track_ip_ranges` (`ip_range` VARCHAR(20) NOT NULL, `site_id` INTEGER UNSIGNED NOT NULL, `ips_max` INTEGER UNSIGNED NOT NULL, `ips_current` INTEGER UNSIGNED NOT NULL, PRIMARY KEY(`ip_range`, `site_id`), INDEX `site_id`(`site_id`))");
print db_execute("ALTER TABLE `mac_track_ip_ranges` ADD COLUMN `ips_max_date` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00' AFTER `ips_current`;");
print db_execute("ALTER TABLE `mac_track_ip_ranges` ADD COLUMN `ips_current_date` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00' AFTER `ips_max_date`;");
print db_execute("ALTER TABLE `mac_track_processes` CHANGE COLUMN `process_id` `device_id` INTEGER NOT NULL DEFAULT 0;");
print db_execute("ALTER TABLE `mac_track_processes` ADD COLUMN `process_id` INTEGER UNSIGNED AFTER `device_id`;");
print db_execute("ALTER TABLE `mac_track_devices` MODIFY COLUMN `snmp_readstring` VARCHAR(30) NOT NULL DEFAULT ''");
print db_execute("ALTER TABLE `mac_track_devices` MODIFY COLUMN `snmp_readstrings` VARCHAR(150) DEFAULT ''");
print db_execute("ALTER TABLE `mac_track_temp_ports` TYPE = HEAP");
print db_execute("ALTER TABLE `mac_track_ips` TYPE = HEAP");

$devices = db_fetch_assoc("SELECT * FROM mac_track_devices");
$device_types = db_fetch_assoc("SELECT * FROM mac_track_device_types");

/* update all known device device_types */
print "\nUpdating Device Types in Devices Table.  Please be patient.\n";
foreach ($devices as $device) {
	$device_type = find_scanning_function($device, $device_types);
	if (sizeof($device_type) > 0) {
		print db_execute("UPDATE mac_track_devices SET device_type_id='" . $device_type["device_type_id"] . "' WHERE device_id='" . $device["device_id"] . "'");
	}
}

?>