<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2005 Larry Adams                                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
chdir('../../');
/* include cacti base functions */
include("./include/auth.php");
include_once("./lib/snmp.php");

/* include base and vendor functions to obtain a list of registered scanning functions */
include_once($config['base_path'] . "/plugins/mactrack/lib/mactrack_functions.php");
include_once($config['base_path'] . "/plugins/mactrack/lib/mactrack_vendors.php");

/* store the list of registered mactrack scanning functions */
db_execute("REPLACE INTO mac_track_scanning_functions (scanning_function) VALUES ('Not Applicable - Router')");
foreach($mactrack_scanning_functions as $scanning_function) {
	db_execute("REPLACE INTO mac_track_scanning_functions (scanning_function) VALUES ('" . $scanning_function . "')");
}

define("MAX_DISPLAY_PAGES", 21);

$device_types_actions = array(
	1 => "Delete"
	);

/* set default action */
if (!isset($_REQUEST["action"])) { $_REQUEST["action"] = ""; }

switch ($_REQUEST["action"]) {
	case 'save':
		form_save();

		break;
	case 'actions':
		form_actions();

		break;
	case 'edit':
		include_once("./include/top_header.php");

		mactrack_device_type_edit();

		include_once("./include/bottom_footer.php");
		break;
	case 'import':
		include_once("./include/top_header.php");

		mactrack_device_type_import();

		include_once("./include/bottom_footer.php");
		break;
	default:
		if (isset($_REQUEST["import_x"])) {
			header("Location: mactrack_device_types.php?action=import");
		}elseif (isset($_REQUEST["export_x"])) {
			mactrack_device_type_export();
		}else{
			include_once("./include/top_header.php");

			mactrack_device_type();

			include_once("./include/bottom_footer.php");
		}
		break;
}

/* --------------------------
    The Save Function
   -------------------------- */

function form_save() {
	if ((isset($_POST["save_component_device_type"])) && (empty($_POST["add_dq_y"]))) {
		$device_type_id = api_mactrack_device_type_save($_POST["device_type_id"], $_POST["description"],
			$_POST["vendor"], $_POST["device_type"], $_POST["sysDescr_match"], $_POST["sysObjectID_match"],
			$_POST["scanning_function"], $_POST["lowPort"], $_POST["highPort"]);

		if ((is_error_message()) || ($_POST["device_type_id"] != $_POST["_device_type_id"])) {
			header("Location: mactrack_device_types.php?action=edit&device_type_id=" . (empty($device_type_id) ? $_POST["device_type_id"] : $device_type_id));
		}else{
			header("Location: mactrack_device_types.php");
		}
	}

	if (isset($_POST["save_component_import"])) {
		if (($_FILES["import_file"]["tmp_name"] != "none") && ($_FILES["import_file"]["tmp_name"] != "")) {
			/* file upload */
			$csv_data = file($_FILES["import_file"]["tmp_name"]);

			/* obtain debug information if it's set */
			$debug_data = mactrack_device_type_import_processor($csv_data);
			if(sizeof($debug_data) > 0) {
				$_SESSION["import_debug_info"] = $debug_data;
			}
		}else{
			header("Location: mactrack_device_types.php?action=import"); exit;
		}

		header("Location: mactrack_device_types.php?action=import");
	}
}

function api_mactrack_device_type_remove($device_type_id){
	db_execute("DELETE FROM mac_track_device_types WHERE device_type_id='" . $device_type_id . "'");
}

function api_mactrack_device_type_save($device_type_id, $description,
			$vendor, $device_type, $sysDescr_match, $sysObjectID_match, $scanning_function,
			$lowPort, $highPort) {

	$save["device_type_id"] = $device_type_id;
	$save["description"] = form_input_validate($description, "description", "", false, 3);
	$save["vendor"] = $vendor;
	$save["device_type"] = $device_type;
	$save["sysDescr_match"] = form_input_validate($sysDescr_match, "sysDescr_match", "", true, 3);
	$save["sysObjectID_match"] = form_input_validate($sysObjectID_match, "sysObjectID_match", "", true, 3);
	$save["scanning_function"] = form_input_validate($scanning_function, "scanning_function", "", true, 3);
	$save["lowPort"] = form_input_validate($lowPort, "lowPort", "", true, 3);
	$save["highPort"] = form_input_validate($highPort, "highPort", "", true, 3);

	$device_type_id = 0;
	if (!is_error_message()) {
		$device_type_id = sql_save($save, "mac_track_device_types", "device_type_id");

		if ($device_type_id) {
			raise_message(1);
		}else{
			raise_message(2);
		}
	}

	return $device_type_id;
}

/* ------------------------
    The "actions" function
   ------------------------ */

function form_actions() {
	global $colors, $config, $device_types_actions, $fields_mactrack_device_types_edit;

	/* if we are to save this form, instead of display it */
	if (isset($_POST["selected_items"])) {
		$selected_items = unserialize(stripslashes($_POST["selected_items"]));

		if ($_POST["drp_action"] == "1") { /* delete */
			for ($i=0; $i<count($selected_items); $i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */

				api_mactrack_device_type_remove($selected_items[$i]);
			}
		}

		header("Location: mactrack_device_types.php");
		exit;
	}

	/* setup some variables */
	$device_types_list = ""; $i = 0;

	/* loop through each of the device types selected on the previous page and get more info about them */
	while (list($var,$val) = each($_POST)) {
		if (ereg("^chk_([0-9]+)$", $var, $matches)) {
			/* ================= input validation ================= */
			input_validate_input_number($matches[1]);
			/* ==================================================== */

			$device_types_info = db_fetch_row("SELECT description FROM mac_track_device_types WHERE device_type_id=" . $matches[1]);
			$device_types_list .= "<li>" . $device_types_info["description"] . "<br>";
			$device_types_array[$i] = $matches[1];
		}

		$i++;
	}

	include_once("./include/top_header.php");

	html_start_box("<strong>" . $device_types_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "3", "center", "");

	print "<form action='mactrack_device_types.php' method='post'>\n";

	if ($_POST["drp_action"] == "1") { /* delete */
		print "	<tr>
				<td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
					<p>Are you sure you want to delete the following device types?</p>
					<p>$device_types_list</p>
				</td>
			</tr>\n
			";
	}

	if (!isset($device_types_array)) {
		print "<tr><td bgcolor='#" . $colors["form_alternate1"]. "'><span class='textError'>You must select at least one device type.</span></td></tr>\n";
		$save_html = "";
	}else{
		$save_html = "<input type='image' src='" . $config['url_path'] . "images/button_yes.gif' alt='Save' align='absmiddle'>";
	}

	print "	<tr>
			<td colspan='2' align='right' bgcolor='#eaeaea'>
				<input type='hidden' name='action' value='actions'>
				<input type='hidden' name='selected_items' value='" . (isset($device_types_array) ? serialize($device_types_array) : '') . "'>
				<input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
				<a href='mactrack_device_types.php'><img src='" . $config['url_path'] . "images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
				$save_html
			</td>
		</tr>
		";

	html_end_box();

	include_once("./include/bottom_footer.php");
}

/* ---------------------
    Mactrack Device Type Functions
   --------------------- */

function mactrack_device_type_export() {
	global $colors, $device_actions, $mactrack_device_types, $config;

	/* remember these search fields in session vars so we don't have to keep passing them around */
	load_current_session_value("page", "sess_mactrack_device_type_current_page", "1");
	load_current_session_value("vendor", "sess_mactrack_device_type_vendor", "All");
	load_current_session_value("type_id", "sess_mactrack_device_type_type_id", "-1");

	$sql_where = "";

	$device_types = mactrack_get_device_types($sql_where, FALSE);

	$xport_array = array();
	array_push($xport_array, '"vendor","description","device_type",' .
		'"sysDescr_match","sysObjectID_match","scanning_function",' .
		'"lowPort","highPort"');

	if (sizeof($device_types)) {
		foreach($device_types as $device_type) {
			array_push($xport_array,'"' . $device_type['vendor'] . '","' .
			$device_type['description'] . '","' .
			$device_type['device_type'] . '","' .
			$device_type['sysDescr_match'] . '","' .
			$device_type['sysObjectID_match'] . '","' .
			$device_type['scanning_function'] . '","' .
			$device_type['lowPort'] . '","' .
			$device_type['highPort'] . '"');
		}
	}

	header("Content-type: application/xml");
	header("Content-Disposition: attachment; filename=cacti_device_type_xport.csv");
	foreach($xport_array as $xport_line) {
		print $xport_line . "\n";
	}
}

function mactrack_device_type_import() {
	global $colors, $config;

	?><form method="post" action="mactrack_device_types.php?action=import" enctype="multipart/form-data"><?php

	if ((isset($_SESSION["import_debug_info"])) && (is_array($_SESSION["import_debug_info"]))) {
		html_start_box("<strong>Import Results</strong>", "98%", "aaaaaa", "3", "center", "");

		print "<tr bgcolor='#" . $colors["form_alternate1"] . "'><td><p class='textArea'>Cacti has imported the following items:</p>";
		foreach($_SESSION["import_debug_info"] as $import_result) {
			print "<tr bgcolor='#" . $colors["form_alternate1"] . "'><td>" . $import_result . "</td>";
			print "</tr>";
		}

		html_end_box();

		kill_session_var("import_debug_info");
	}

	html_start_box("<strong>Import MacTrack Device Types</strong>", "98%", $colors["header"], "3", "center", "");

	form_alternate_row_color($colors["form_alternate1"],$colors["form_alternate2"],0);?>
		<td width='50%'><font class='textEditTitle'>Import Device Types from Local File</font><br>
			Please specify the location of the CSV file containing your device type information.
			This file must contain a header row with the correct column names.
		</td>
		<td>
			<input type='file' name='import_file'>
		</td>
	</tr><?php

	form_hidden_box("save_component_import","1","");

	html_end_box();

	form_save_button("mactrack_device_types.php", "save");
}

function mactrack_device_type_import_processor(&$device_types) {
	$i = 0;
	$return_array = array();

	foreach($device_types as $device_type) {
		/* parse line */
		$line_array = explode(",", $device_type);

		/* header row */
		if ($i == 0) {
			$save_order = "(";
			$j = 0;
			foreach($line_array as $line_item) {
				$line_item = trim(str_replace("'", "", $line_item));
				$line_item = trim(str_replace('"', '', $line_item));

				if ($j != 0) {
					$save_order .= ",";
				}

				switch ($line_item) {
					case 'device_type':
					case 'sysDescr_match':
					case 'sysObjectID_match':
					case 'scanning_function':
					case 'lowPort':
					case 'highPort':
						$save_order .= $line_item;
						break;
					case 'vendor':
						$save_order .= $line_item;
						$save_vendor_id = $j;
						break;
					case 'description':
						$save_order .= $line_item;
						$save_description_id = $j;
						break;
					default:
						return array("<strong>HEADER ERROR: No Rows Imported</strong>: The Header Line is not formatted correctly.  Correct
							header columns include 'description', 'vendor', 'device_type',
							'sysDescr_match', 'sysObjectID_match', 'lowPort', 'highPort',
							and 'scanning_function'.");
				}

				$j++;

			}
			array_push($return_array, "<strong>HEADER LINE PROCESSED OK</strong>");

			$save_order .= ")";
		}else{
			$save_value = "(";
			$j = 0;
			foreach($line_array as $line_item) {
				$line_item = trim(str_replace("'", "", $line_item));
				$line_item = trim(str_replace('"', '', $line_item));

				if ($j != 0) {
					$save_value .= ",";
				}

				if ($j == $save_vendor_id) {
					$vendor = $line_item;
				}

				if ($j == $save_description_id) {
					$description = $line_item;
				}

				$j++;

				$save_value .= "'" . $line_item . "'";
			}

			$save_value .= ")";

			$sql_execute = "INSERT INTO mac_track_device_types " . $save_order .
				" VALUES" . $save_value;

			if (db_execute($sql_execute)) {
				array_push($return_array,"INSERT SUCCEEDED: Vendor: $vendor Description: $description");
			}else{
				array_push($return_array,"<strong>INSERT FAILED:</strong> Vendor: $vendor Description: $description");
			}
		}

		$i++;
	}

	return $return_array;
}

function mactrack_device_type_remove() {
	global $config;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("device_type_id"));
	/* ==================================================== */

	if ((read_config_option("remove_verification") == "on") && (!isset($_GET["confirm"]))) {
		include("./include/top_header.php");
		form_confirm("Are You Sure?", "Are you sure you want to delete the device type<strong>'" . db_fetch_cell("select description from host where id=" . $_GET["device_id"]) . "'</strong>?", "mactrack_device_types.php", "mactrack_device_types.php?action=remove&id=" . $_GET["device_type_id"]);
		include("./include/bottom_footer.php");
		exit;
	}

	if ((read_config_option("remove_verification") == "") || (isset($_GET["confirm"]))) {
		api_mactrack_device_type_remove($_GET["device_type_id"]);
	}
}

function mactrack_device_type_edit() {
	global $colors, $fields_mactrack_device_type_edit;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("device_type_id"));
	/* ==================================================== */

	display_output_messages();

	if (!empty($_GET["device_type_id"])) {
		$device_type = db_fetch_row("select * from mac_track_device_types where device_type_id=" . $_GET["device_type_id"]);
		$header_label = "[edit: " . $device_type["description"] . "]";
	}else{
		$header_label = "[new]";
	}

	html_start_box("<strong>Mac Track Device Types</strong> $header_label", "98%", $colors["header"], "3", "center", "");

	draw_edit_form(array(
		"config" => array("form_name" => "chk"),
		"fields" => inject_form_variables($fields_mactrack_device_type_edit, (isset($device_type) ? $device_type : array()))
		));

	html_end_box();

	form_save_button("mactrack_device_types.php", "", "device_type_id");
}

function mactrack_get_device_types(&$sql_where, $apply_limits = TRUE) {
	if ($_REQUEST["vendor"] == "All") {
		/* Show all items */
	}else{
		$sql_where = " WHERE (mac_track_device_types.vendor='" . $_REQUEST["vendor"] . "')";
	}

	if ($_REQUEST["type_id"] == "-1") {
		/* Show all items */
	}else{
		if (strlen($sql_where) > 0) {
			$sql_where .= " AND (mac_track_device_types.device_type=" . $_REQUEST["type_id"] . ")";
		}else{
			$sql_where .= " WHERE (mac_track_device_types.device_type=" . $_REQUEST["type_id"] . ")";
		}
	}

	$query_string = "SELECT
		mac_track_device_types.device_type_id,
		mac_track_device_types.description,
		mac_track_device_types.vendor,
		mac_track_device_types.device_type,
		mac_track_device_types.sysDescr_match,
		mac_track_device_types.sysObjectID_match,
		mac_track_device_types.scanning_function,
		mac_track_device_types.lowPort,
		mac_track_device_types.highPort
		FROM mac_track_device_types
		$sql_where
		ORDER BY " . $_REQUEST["sort_column"] . " " . $_REQUEST["sort_direction"];

	if ($apply_limits) {
		$query_string .= " LIMIT " . (read_config_option("num_rows_mactrack")*($_REQUEST["page"]-1)) . "," . read_config_option("num_rows_mactrack");
	}

	return db_fetch_assoc($query_string);
}

function mactrack_device_type() {
	global $colors, $device_types_actions, $mactrack_device_types, $config;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var_request("page"));
	input_validate_input_number(get_request_var_request("type_id"));
	/* ==================================================== */

	/* clean up the vendor string */
	if (isset($_REQUEST["vendor"])) {
		$_REQUEST["vendor"] = sanitize_search_string(get_request_var("vendor"));
	}

	/* clean up sort_column */
	if (isset($_REQUEST["sort_column"])) {
		$_REQUEST["sort_column"] = sanitize_search_string(get_request_var("sort_column"));
	}

	/* clean up search string */
	if (isset($_REQUEST["sort_direction"])) {
		$_REQUEST["sort_direction"] = sanitize_search_string(get_request_var("sort_direction"));
	}

	/* if the user pushed the 'clear' button */
	if (isset($_REQUEST["clear_x"])) {
		kill_session_var("sess_mactrack_device_current_page");
		kill_session_var("sess_mactrack_device_filter");
		kill_session_var("sess_mactrack_device_type_vendor");
		kill_session_var("sess_mactrack_device_type_type_id");
		kill_session_var("sess_mactrack_device_type_sort_column");
		kill_session_var("sess_mactrack_device_type_sort_direction");

		unset($_REQUEST["page"]);
		unset($_REQUEST["vendor"]);
		unset($_REQUEST["type_id"]);
		unset($_REQUEST["sort_column"]);
		unset($_REQUEST["sort_direction"]);
	}

	/* remember these search fields in session vars so we don't have to keep passing them around */
	load_current_session_value("page", "sess_mactrack_device_type_current_page", "1");
	load_current_session_value("vendor", "sess_mactrack_device_type_vendor", "All");
	load_current_session_value("type_id", "sess_mactrack_device_type_type_id", "-1");
   	load_current_session_value("sort_column", "sess_mactrack_device_type_sort_column", "description");
	load_current_session_value("sort_direction", "sess_mactrack_device_type_sort_direction", "ASC");

	html_start_box("<strong>Mac Track Device Type Filters</strong>", "98%", $colors["header"], "3", "center", "mactrack_device_types.php?action=edit");

	include("plugins/mactrack/html/inc_mactrack_device_type_filter_table.php");

	html_end_box();

	$sql_where = "";

	$device_types = mactrack_get_device_types($sql_where);

	html_start_box("", "98%", $colors["header"], "3", "center", "");

	$total_rows = db_fetch_cell("SELECT
		COUNT(mac_track_device_types.device_type_id)
		FROM mac_track_device_types" . $sql_where);

	/* generate page list */
	$url_page_select = get_page_list($_REQUEST["page"], MAX_DISPLAY_PAGES, read_config_option("num_rows_mactrack"), $total_rows, "mactrack_device_types.php?");

	$nav = "<tr bgcolor='#" . $colors["header"] . "'>
			<td colspan='7'>
				<table width='100%' cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td align='left' class='textHeaderDark'>
							<strong>&lt;&lt; "; if ($_REQUEST["page"] > 1) { $nav .= "<a class='linkOverDark' href='mactrack_device_types.php?page=" . ($_REQUEST["page"]-1) . "'>"; } $nav .= "Previous"; if ($_REQUEST["page"] > 1) { $nav .= "</a>"; } $nav .= "</strong>
						</td>\n
						<td align='center' class='textHeaderDark'>
							Showing Rows " . ((read_config_option("num_rows_mactrack")*($_REQUEST["page"]-1))+1) . " to " . ((($total_rows < read_config_option("num_rows_mactrack")) || ($total_rows < (read_config_option("num_rows_mactrack")*$_REQUEST["page"]))) ? $total_rows : (read_config_option("num_rows_mactrack")*$_REQUEST["page"])) . " of $total_rows [$url_page_select]
						</td>\n
						<td align='right' class='textHeaderDark'>
							<strong>"; if (($_REQUEST["page"] * read_config_option("num_rows_mactrack")) < $total_rows) { $nav .= "<a class='linkOverDark' href='mactrack_device_types.php?page=" . ($_REQUEST["page"]+1) . "'>"; } $nav .= "Next"; if (($_REQUEST["page"] * read_config_option("num_rows_mactrack")) < $total_rows) { $nav .= "</a>"; } $nav .= " &gt;&gt;</strong>
						</td>\n
					</tr>
				</table>
			</td>
		</tr>\n";

	print $nav;

	$display_text = array(
		"description" => array("Device Type<br>Description", "ASC"),
		"vendor" => array("<br>Devices", "DESC"),
		"device_type" => array("Device<br>Type", "DESC"),
		"sysDescr_match" => array("sysDescription<br>Match", "DESC"),
		"sysObjectID_match" => array("Vendor OID<br>Match", "DESC"));

	html_header_sort_checkbox($display_text, $_REQUEST["sort_column"], $_REQUEST["sort_direction"]);

	$i = 0;
	if (sizeof($device_types) > 0) {
		foreach ($device_types as $device_type) {
			form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
				?>
				<td width=170>
					<a class="linkEditMain" href="mactrack_device_types.php?action=edit&device_type_id=<?php print $device_type["device_type_id"];?>"><?php print $device_type["description"];?></a>
				</td>
				<td><?php print $device_type["vendor"];?></td>
				<td><?php print $mactrack_device_types[$device_type["device_type"]];?></td>
				<td><?php print $device_type["sysDescr_match"];?></td>
				<td><?php print $device_type["sysObjectID_match"];?></td>
				<td style="<?php print get_checkbox_style();?>" width="1%" align="right">
					<input type='checkbox' style='margin: 0px;' name='chk_<?php print $device_type["device_type_id"];?>' title="<?php print $device_type["description"];?>">
				</td>
			</tr>
			<?php
		}

		/* put the nav bar on the bottom as well */
		print $nav;
	}else{
		print "<tr><td><em>No Mac Track Device Types</em></td></tr>";
	}
	html_end_box(false);

	/* draw the dropdown containing a list of available actions for this form */
	draw_actions_dropdown($device_types_actions);
}

?>