<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2005 Larry Adams                                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
chdir('../../');
include("./include/auth.php");
include_once("./lib/snmp.php");

define("MAX_DISPLAY_PAGES", 21);

$device_actions = array(
	1 => "Delete",
	2 => "Enable",
	3 => "Disable",
	4 => "Change SNMP Options",
	5 => "Change Device Port Values"
	);

/* set default action */
if (!isset($_REQUEST["action"])) { $_REQUEST["action"] = ""; }

switch ($_REQUEST["action"]) {
	case 'save':
		form_save();

		break;
	case 'actions':
		form_actions();

		break;
	case 'edit':
		include_once("./include/top_header.php");

		mactrack_device_edit();

		include_once("./include/bottom_footer.php");
		break;
	case 'import':
		include_once("./include/top_header.php");

		mactrack_device_import();

		include_once("./include/bottom_footer.php");
		break;
	default:
		if (isset($_REQUEST["import_x"])) {
			header("Location: mactrack_devices.php?action=import");
		}elseif (isset($_REQUEST["export_x"])) {
			mactrack_device_export();
		}else{
			include_once("./include/top_header.php");

			mactrack_device();

			include_once("./include/bottom_footer.php");
		}
		break;
}

/* --------------------------
    The Save Function
   -------------------------- */

function form_save() {
	if ((isset($_POST["save_component_device"])) && (empty($_POST["add_dq_y"]))) {
		$device_id = api_mactrack_device_save($_POST["device_id"], $_POST["site_id"],
			$_POST["hostname"], $_POST["description"], $_POST["scan_type"],
			$_POST["snmp_readstring"], $_POST["snmp_readstrings"],
			$_POST["snmp_version"],	$_POST["snmp_port"], $_POST["snmp_timeout"],
			$_POST["snmp_retries"], $_POST["port_ignorePorts"],
			(isset($_POST["disabled"]) ? $_POST["disabled"] : ""));

		if ((is_error_message()) || ($_POST["device_id"] != $_POST["_device_id"])) {
			header("Location: mactrack_devices.php?action=edit&device_id=" . (empty($device_id) ? $_POST["device_id"] : $device_id));
		}else{
			header("Location: mactrack_devices.php");
		}
	}

	if (isset($_POST["save_component_import"])) {
		if (($_FILES["import_file"]["tmp_name"] != "none") && ($_FILES["import_file"]["tmp_name"] != "")) {
			/* file upload */
			$csv_data = file($_FILES["import_file"]["tmp_name"]);

			/* obtain debug information if it's set */
			$debug_data = mactrack_device_import_processor($csv_data);
			if(sizeof($debug_data) > 0) {
				$_SESSION["import_debug_info"] = $debug_data;
			}
		}else{
			header("Location: mactrack_devices.php?action=import"); exit;
		}

		header("Location: mactrack_devices.php?action=import");
	}
}

function api_mactrack_device_remove($device_id){
	db_execute("DELETE FROM mac_track_devices WHERE device_id=" . $device_id);
}

function api_mactrack_device_save($device_id, $site_id, $hostname,
			$description, $scan_type, $snmp_readstring, $snmp_readstrings,
			$snmp_version, $snmp_port, $snmp_timeout, $snmp_retries,
			$ignorePorts, $disabled) {

	$save["device_id"] = $device_id;
	$save["site_id"] = $site_id;
	$save["hostname"] = form_input_validate($hostname, "hostname", "", false, 3);
	$save["description"] = form_input_validate($description, "description", "", false, 3);
	$save["scan_type"] = form_input_validate($scan_type, "scan_type", "", false, 3);
	$save["snmp_readstring"] = form_input_validate($snmp_readstring, "snmp_readstring", "", false, 3);
	$save["snmp_readstrings"] = form_input_validate($snmp_readstrings, "snmp_readstrings", "", true, 3);
	$save["snmp_version"] = form_input_validate($snmp_version, "snmp_version", "", false, 3);
	$save["snmp_port"] = form_input_validate($snmp_port, "snmp_port", "^[0-9]+$", false, 3);
	$save["snmp_timeout"] = form_input_validate($snmp_timeout, "snmp_timeout", "^[0-9]+$", false, 3);
	$save["snmp_retries"] = form_input_validate($snmp_retries, "snmp_retries", "^[0-9]+$", false, 3);
	$save["ignorePorts"] = form_input_validate($ignorePorts, "port_ignorePorts", "", true, 3);
	$save["disabled"] = form_input_validate($disabled, "disabled", "", true, 3);

	$device_id = 0;
	if (!is_error_message()) {
		$device_id = sql_save($save, "mac_track_devices", "device_id");

		if ($device_id) {
			raise_message(1);
		}else{
			raise_message(2);
		}
	}

	return $device_id;
}


/* ------------------------
    The "actions" function
   ------------------------ */

function form_actions() {
	global $colors, $config, $device_actions, $fields_mactrack_device_edit;

	/* if we are to save this form, instead of display it */
	if (isset($_POST["selected_items"])) {
		$selected_items = unserialize(stripslashes($_POST["selected_items"]));

		if ($_POST["drp_action"] == "2") { /* Enable Selected Devices */
			for ($i=0;($i<count($selected_items));$i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */

				db_execute("update mac_track_devices set disabled='' where device_id='" . $selected_items[$i] . "'");
			}
		}elseif ($_POST["drp_action"] == "3") { /* Disable Selected Devices */
			for ($i=0;($i<count($selected_items));$i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */

				db_execute("update mac_track_devices set disabled='on' where device_id='" . $selected_items[$i] . "'");
			}
		}elseif ($_POST["drp_action"] == "4") { /* change snmp options */
			for ($i=0;($i<count($selected_items));$i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */

				reset($fields_mactrack_device_edit);
				while (list($field_name, $field_array) = each($fields_mactrack_device_edit)) {
					if (isset($_POST["t_$field_name"])) {
						db_execute("update mac_track_devices set $field_name = '" . $_POST[$field_name] . "' where device_id='" . $selected_items[$i] . "'");
					}
				}
			}
		}elseif ($_POST["drp_action"] == "5") { /* change port settngs for multiple devices */
			for ($i=0;($i<count($selected_items));$i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */

				reset($fields_mactrack_device_edit);
				while (list($field_name, $field_array) = each($fields_host_edit)) {
					if (isset($_POST["t_$field_name"])) {
						db_execute("update mac_track_devices set $field_name = '" . $_POST[$field_name] . "' where id='" . $selected_items[$i] . "'");
					}
				}
			}
		}elseif ($_POST["drp_action"] == "1") { /* delete */
			for ($i=0; $i<count($selected_items); $i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */

				api_mactrack_device_remove($selected_items[$i]);
			}
		}

		header("Location: mactrack_devices.php");
		exit;
	}

	/* setup some variables */
	$device_list = ""; $i = 0;

	/* loop through each of the host templates selected on the previous page and get more info about them */
	while (list($var,$val) = each($_POST)) {
		if (ereg("^chk_([0-9]+)$", $var, $matches)) {
			/* ================= input validation ================= */
			input_validate_input_number($matches[1]);
			/* ==================================================== */

			$device_info = db_fetch_row("SELECT hostname, description FROM mac_track_devices WHERE device_id=" . $matches[1]);
			$device_list .= "<li>" . $device_info["description"] . " (" . $device_info["hostname"] . ")<br>";
			$device_array[$i] = $matches[1];
		}

		$i++;
	}

	include_once("./include/top_header.php");

	html_start_box("<strong>" . $device_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "3", "center", "");

	print "<form action='mactrack_devices.php' method='post'>\n";

	if ($_POST["drp_action"] == "2") { /* Enable Devices */
		print "	<tr>
				<td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
					<p>To enable the following devices, press the \"yes\" button below.</p>
					<p>$device_list</p>
				</td>
				</tr>";
	}elseif ($_POST["drp_action"] == "3") { /* Disable Devices */
		print "	<tr>
				<td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
					<p>To disable the following devices, press the \"yes\" button below.</p>
					<p>$device_list</p>
				</td>
				</tr>";
	}elseif ($_POST["drp_action"] == "4") { /* change snmp options */
		print "	<tr>
				<td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
					<p>To change SNMP parameters for the following devices, check the box next to the fields
					you want to update, fill in the new value, and click Save.</p>
					<p>$device_list</p>
				</td>
				</tr>";
				$form_array = array();
				while (list($field_name, $field_array) = each($fields_mactrack_device_edit)) {
					if (ereg("^snmp_", $field_name)) {
						$form_array += array($field_name => $fields_mactrack_device_edit[$field_name]);

						$form_array[$field_name]["value"] = "";
						$form_array[$field_name]["description"] = "";
						$form_array[$field_name]["form_id"] = 0;
						$form_array[$field_name]["sub_checkbox"] = array(
							"name" => "t_" . $field_name,
							"friendly_name" => "Update this Field",
							"value" => ""
							);
					}
				}

				draw_edit_form(
					array(
						"config" => array("no_form_tag" => true),
						"fields" => $form_array
						)
					);
	}elseif ($_POST["drp_action"] == "5") { /* change port settngs for multiple devices */
		print "	<tr>
				<td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
					<p>To change upper or lower port parameters for the following devices, check the box next to the fields
					you want to update, fill in the new value, and click Save.</p>
					<p>$device_list</p>
				</td>
				</tr>";
				$form_array = array();
				while (list($field_name, $field_array) = each($fields_mactrack_device_edit)) {
					if (ereg("^port_", $field_name)) {
						$form_array += array($field_name => $fields_mactrack_device_edit[$field_name]);

						$form_array[$field_name]["value"] = "";
						$form_array[$field_name]["description"] = "";
						$form_array[$field_name]["form_id"] = 0;
						$form_array[$field_name]["sub_checkbox"] = array(
							"name" => "t_" . $field_name,
							"friendly_name" => "Update this Field",
							"value" => ""
							);
					}
				}

				draw_edit_form(
					array(
						"config" => array("no_form_tag" => true),
						"fields" => $form_array
						)
					);
	}elseif ($_POST["drp_action"] == "1") { /* delete */
		print "	<tr>
				<td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
					<p>Are you sure you want to delete the following devices?</p>
					<p>$device_list</p>
				</td>
			</tr>\n
			";
	}

	if (!isset($device_array)) {
		print "<tr><td bgcolor='#" . $colors["form_alternate1"]. "'><span class='textError'>You must select at least one device.</span></td></tr>\n";
		$save_html = "";
	}else{
		$save_html = "<input type='image' src='" . $config['url_path'] . "images/button_yes.gif' alt='Save' align='absmiddle'>";
	}

	print "	<tr>
			<td colspan='2' align='right' bgcolor='#eaeaea'>
				<input type='hidden' name='action' value='actions'>
				<input type='hidden' name='selected_items' value='" . (isset($device_array) ? serialize($device_array) : '') . "'>
				<input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
				<a href='mactrack_devices.php'><img src='" . $config['url_path'] . "images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
				$save_html
			</td>
		</tr>
		";

	html_end_box();

	include_once("./include/bottom_footer.php");
}

/* ---------------------
    Mactrack Device Functions
   --------------------- */

function mactrack_device_export() {
	/* remember these search fields in session vars so we don't have to keep passing them around */
	load_current_session_value("page", "sess_mactrack_device_current_page", "1");
	load_current_session_value("filter", "sess_mactrack_device_filter", "");
	load_current_session_value("site_id", "sess_mactrack_device_site_id", "-1");
	load_current_session_value("type_id", "sess_mactrack_device_type_id", "-1");
	load_current_session_value("device_type_id", "sess_mactrack_device_device_type_id", "-1");
	load_current_session_value("status", "sess_mactrack_device_status", "-1");

	$sql_where = "";

	$devices = mactrack_get_devices($sql_where, FALSE);

	$xport_array = array();
	array_push($xport_array, '"site_id","site_name","device_id","description",' .
		'"hostname", "snmp_readstring","snmp_readstrings","snmp_version",' .
		'"snmp_port","snmp_timeout","snmp_retries","ignorePorts",' .
		'"scan_type","disabled","ports_total","ports_active","ports_trunk",' .
		'"macs_active","last_rundate","last_runduration"');

	if (sizeof($devices)) {
		foreach($devices as $device) {
			array_push($xport_array,'"' . $device['site_id'] . '","' .
			$device['site_name'] . '","' . $device['device_id'] . '","' .
			$device['description'] . '","' . $device['hostname'] . '","' .
			$device['snmp_readstring'] . '","' . $device['snmp_readstrings'] . '","' .
			$device['snmp_version'] . '","' . $device['snmp_port'] . '","' .
			$device['snmp_timeout'] . '","' . $device['snmp_retries'] . '","' .
			$device['ignorePorts'] . '","' . $device['scan_type'] . '","' .
			$device['disabled'] . '","' . $device['ports_total'] . '","' .
			$device['ports_active'] . '","' . $device['ports_trunk'] . '","' .
			$device['macs_active'] . '","' . $device['last_rundate'] . '","' .
			$device['last_runduration'] . '"');
		}
	}

	header("Content-type: application/xml");
	header("Content-Disposition: attachment; filename=cacti_device_xport.csv");
	foreach($xport_array as $xport_line) {
		print $xport_line . "\n";
	}
}

function mactrack_device_import() {
	global $colors, $config;

	?><form method="post" action="mactrack_devices.php?action=import" enctype="multipart/form-data"><?php

	if ((isset($_SESSION["import_debug_info"])) && (is_array($_SESSION["import_debug_info"]))) {
		html_start_box("<strong>Import Results</strong>", "98%", "aaaaaa", "3", "center", "");

		print "<tr bgcolor='#" . $colors["form_alternate1"] . "'><td><p class='textArea'>Cacti has imported the following items:</p>";
		foreach($_SESSION["import_debug_info"] as $import_result) {
			print "<tr bgcolor='#" . $colors["form_alternate1"] . "'><td>" . $import_result . "</td>";
			print "</tr>";
		}

		html_end_box();

		kill_session_var("import_debug_info");
	}

	html_start_box("<strong>Import MacTrack Devices</strong>", "98%", $colors["header"], "3", "center", "");

	form_alternate_row_color($colors["form_alternate1"],$colors["form_alternate2"],0);?>
		<td width='50%'><font class='textEditTitle'>Import Devices from Local File</font><br>
			Please specify the location of the CSV file containing your device information.
			This file must contain a header row with the correct column names.
		</td>
		<td>
			<input type='file' name='import_file'>
		</td>
	</tr><?php

	form_hidden_box("save_component_import","1","");

	html_end_box();

	form_save_button("mactrack_devices.php", "save");
}

function mactrack_device_import_processor(&$devices) {
	$i = 0;
	$return_array = array();

	foreach($devices as $device_line) {
		/* parse line */
		$line_array = explode(",", $device_line);

		/* header row */
		if ($i == 0) {
			$save_order = "(";
			$j = 0;
			foreach($line_array as $line_item) {
				$line_item = trim(str_replace("'", "", $line_item));
				$line_item = trim(str_replace('"', '', $line_item));

				if ($j != 0) {
					$save_order .= ",";
				}

				switch ($line_item) {
					case 'site_id':
					case 'snmp_readstring':
					case 'snmp_readstrings':
					case 'snmp_timeout':
					case 'snmp_retries':
					case 'snmp_port':
					case 'ignorePorts':
					case 'scan_type':
					case 'snmp_version':
					case 'disabled':
						$save_order .= $line_item;
						break;
					case 'hostname':
						$save_order .= $line_item;
						$save_host_id = $j;
						break;
					case 'description':
						$save_order .= $line_item;
						$save_description_id = $j;
						break;
					default:
						return array("<strong>HEADER ERROR: No Rows Imported</strong>: The Header Line is not formatted correctly.  Correct
							header columns include 'site_id', 'hostname', 'description',
							'snmp_readstring', 'snmp_readstrings', 'snmp_version', 'snmp_timeout',
							'snmp_port', 'snmp_retries', 'ignorePorts', 'scan_type', 'disabled'.  Column '$line_item' is incorrect.");
				}

				$j++;

			}
			array_push($return_array, "<strong>HEADER LINE PROCESSED OK</strong>");

			$save_order .= ")";
		}else{
			$save_value = "(";
			$j = 0;
			foreach($line_array as $line_item) {
				$line_item = trim(str_replace("'", "", $line_item));
				$line_item = trim(str_replace('"', '', $line_item));

				if ($j != 0) {
					$save_value .= ",";
				}

				if ($j == $save_host_id) {
					$hostname = $line_item;
				}

				if ($j == $save_description_id) {
					$description = $line_item;
				}

				$j++;

				$save_value .= "'" . $line_item . "'";
			}

			$save_value .= ")";

			$sql_execute = "INSERT INTO mac_track_devices " . $save_order .
				" VALUES" . $save_value;

			if (db_execute($sql_execute)) {
				array_push($return_array,"INSERT SUCCEEDED: Hostname: $hostname Description: $description");
			}else{
				array_push($return_array,"<strong>INSERT FAILED:</strong> Hostname: $hostname Description: $description");
			}
		}

		$i++;
	}

	return $return_array;
}

function mactrack_device_remove() {
	global $config;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("device_id"));
	input_validate_input_number(get_request_var("type_id"));
	/* ==================================================== */

	if ((read_config_option("remove_verification") == "on") && (!isset($_GET["confirm"]))) {
		include("./include/top_header.php");
		form_confirm("Are You Sure?", "Are you sure you want to delete the host <strong>'" . db_fetch_cell("select description from host where id=" . $_GET["device_id"]) . "'</strong>?", "mactrack_devices.php", "mactrack_devices.php?action=remove&id=" . $_GET["device_id"]);
		include("./include/bottom_footer.php");
		exit;
	}

	if ((read_config_option("remove_verification") == "") || (isset($_GET["confirm"]))) {
		api_mactrack_device_remove($_GET["device_id"]);
	}
}

function mactrack_device_edit() {
	global $colors, $fields_mactrack_device_edit;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("device_id"));
	/* ==================================================== */

	display_output_messages();

	if (!empty($_GET["device_id"])) {
		$device = db_fetch_row("select * from mac_track_devices where device_id=" . $_GET["device_id"]);
		$header_label = "[edit: " . $device["description"] . "]";
	}else{
		$header_label = "[new]";
	}

	if (!empty($device["device_id"])) {
		?>
		<table width="98%" align="center">
			<tr>
				<td class="textInfo" colspan="2">
					<?php print $device["description"];?> (<?php print $device["hostname"];?>)
				</td>
			</tr>
			<tr>
				<td class="textHeader">
					SNMP Information<br>

					<span style="font-size: 10px; font-weight: normal; font-family: monospace;">
					<?php
					/* force php to return numeric oid's */
					if (function_exists("snmp_set_oid_numeric_print")) {
						snmp_set_oid_numeric_print(TRUE);
					}

					$snmp_system = cacti_snmp_get($device["hostname"], $device["snmp_readstring"], ".1.3.6.1.2.1.1.1.0", $device["snmp_version"], "", "", $device["snmp_port"], $device["snmp_timeout"], SNMP_WEBUI);

					if ($snmp_system == "") {
						print "<span style='color: #ff0000; font-weight: bold;'>SNMP error</span>\n";
					}else{
						$snmp_uptime = cacti_snmp_get($device["hostname"], $device["snmp_readstring"], ".1.3.6.1.2.1.1.3.0", $device["snmp_version"], "", "", $device["snmp_port"], $device["snmp_timeout"], SNMP_WEBUI);
						$snmp_hostname = cacti_snmp_get($device["hostname"], $device["snmp_readstring"], ".1.3.6.1.2.1.1.5.0", $device["snmp_version"], "", "", $device["snmp_port"], $device["snmp_timeout"], SNMP_WEBUI);
						$snmp_objid = cacti_snmp_get($device["hostname"], $device["snmp_readstring"], ".1.3.6.1.2.1.1.2.0", $device["snmp_version"], "", "", $device["snmp_port"], $device["snmp_timeout"], SNMP_WEBUI);

						$snmp_objid = str_replace("enterprises", ".1.3.6.1.4.1", $snmp_objid);
						$snmp_objid = str_replace("OID: ", "", $snmp_objid);
						$snmp_objid = str_replace(".iso", ".1", $snmp_objid);

						print "<strong>System:</strong> $snmp_system<br>\n";
						print "<strong>Uptime:</strong> $snmp_uptime<br>\n";
						print "<strong>Hostname:</strong> $snmp_hostname<br>\n";
						print "<strong>ObjectID:</strong> $snmp_objid<br>\n";
					}
					?>
					</span>
				</td>
			</tr>
		</table>
		<br>
		<?php
	}

	html_start_box("<strong>Mac Track Devices</strong> $header_label", "98%", $colors["header"], "3", "center", "");

	/* preserve the devices site id between refreshes via a GET variable */
	if (!empty($_GET["site_id"])) {
		$fields_host_edit["site_id"]["value"] = $_GET["site_id"];
	}

	draw_edit_form(array(
		"config" => array("form_name" => "chk"),
		"fields" => inject_form_variables($fields_mactrack_device_edit, (isset($device) ? $device : array()))
		));

	html_end_box();

	form_save_button("mactrack_devices.php", "", "device_id");
}

function mactrack_get_devices(&$sql_where, $apply_limits = TRUE) {
	/* form the 'where' clause for our main sql query */
	$sql_where = "WHERE ((mac_track_devices.hostname like '%%" . $_REQUEST["filter"] . "%%' OR mac_track_devices.description like '%%" . $_REQUEST["filter"] . "%%')";

	if ($_REQUEST["status"] == "-1") {
		/* Show all items */
	}elseif ($_REQUEST["status"] == "-2") {
		$sql_where .= " AND mac_track_devices.disabled='on'";
	}else {
		$sql_where .= " AND (mac_track_devices.snmp_status=" . $_REQUEST["status"] . " AND mac_track_devices.disabled = '')";
	}

	if ($_REQUEST["type_id"] == "-1") {
		/* Show all items */
	}else {
		$sql_where .= " AND mac_track_devices.scan_type=" . $_REQUEST["type_id"];
	}

	if ($_REQUEST["device_type_id"] == "-1") {
		/* Show all items */
	}else{
		$sql_where .= " AND (mac_track_devices.device_type_id=" . $_REQUEST["device_type_id"] . ")";
	}

	if ($_REQUEST["site_id"] == "-1") {
		$sql_where .= ")";
		/* Show all items */
	}elseif ($_REQUEST["site_id"] == "-2") {
		$sql_where .= " AND (mac_track_sites.site_id IS NULL))";
	}elseif (!empty($_REQUEST["site_id"])) {
		$sql_where .= " AND mac_track_devices.site_id=" . $_REQUEST["site_id"] . ")";
	}

	$query_string = "SELECT
		mac_track_devices.site_id,
		mac_track_sites.site_name,
		mac_track_devices.device_id,
		mac_track_devices.description,
		mac_track_devices.hostname,
		mac_track_devices.snmp_readstring,
		mac_track_devices.snmp_readstrings,
		mac_track_devices.snmp_version,
		mac_track_devices.snmp_port,
		mac_track_devices.snmp_timeout,
		mac_track_devices.snmp_retries,
		mac_track_devices.snmp_status,
		mac_track_devices.ignorePorts,
		mac_track_devices.disabled,
		mac_track_devices.scan_type,
		mac_track_devices.ips_total,
		mac_track_devices.ports_total,
		mac_track_devices.ports_active,
		mac_track_devices.ports_trunk,
		mac_track_devices.macs_active,
		mac_track_devices.last_rundate,
		mac_track_devices.last_runmessage,
		mac_track_devices.last_runduration
		FROM mac_track_sites
		RIGHT JOIN mac_track_devices ON mac_track_devices.site_id = mac_track_sites.site_id
		$sql_where
		ORDER BY " . $_REQUEST["sort_column"] . " " . $_REQUEST["sort_direction"];

	if ($apply_limits) {
		$query_string .= " LIMIT " . (read_config_option("num_rows_mactrack")*($_REQUEST["page"]-1)) . "," . read_config_option("num_rows_mactrack");
	}

	return db_fetch_assoc($query_string);
}

function mactrack_device() {
	global $colors, $device_actions, $mactrack_device_types, $config;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var_request("site_id"));
	input_validate_input_number(get_request_var_request("type_id"));
	input_validate_input_number(get_request_var_request("device_type_id"));
	input_validate_input_number(get_request_var_request("page"));
	input_validate_input_number(get_request_var_request("status"));
	/* ==================================================== */

	/* clean up search string */
	if (isset($_REQUEST["filter"])) {
		$_REQUEST["filter"] = sanitize_search_string(get_request_var("filter"));
	}

	/* clean up sort_column */
	if (isset($_REQUEST["sort_column"])) {
		$_REQUEST["sort_column"] = sanitize_search_string(get_request_var("sort_column"));
	}

	/* clean up search string */
	if (isset($_REQUEST["sort_direction"])) {
		$_REQUEST["sort_direction"] = sanitize_search_string(get_request_var("sort_direction"));
	}

	/* if the user pushed the 'clear' button */
	if (isset($_REQUEST["clear_x"])) {
		kill_session_var("sess_mactrack_device_current_page");
		kill_session_var("sess_mactrack_device_filter");
		kill_session_var("sess_mactrack_device_site_id");
		kill_session_var("sess_mactrack_device_type_id");
		kill_session_var("sess_mactrack_device_device_type_id");
		kill_session_var("sess_mactrack_device_status");
		kill_session_var("sess_mactrack_device_sort_column");
		kill_session_var("sess_mactrack_device_sort_direction");

		unset($_REQUEST["page"]);
		unset($_REQUEST["filter"]);
		unset($_REQUEST["site_id"]);
		unset($_REQUEST["type_id"]);
		unset($_REQUEST["device_type_id"]);
		unset($_REQUEST["status"]);
		unset($_REQUEST["sort_column"]);
		unset($_REQUEST["sort_direction"]);
	}

	/* remember these search fields in session vars so we don't have to keep passing them around */
	load_current_session_value("page", "sess_mactrack_device_current_page", "1");
	load_current_session_value("filter", "sess_mactrack_device_filter", "");
	load_current_session_value("site_id", "sess_mactrack_device_site_id", "-1");
	load_current_session_value("type_id", "sess_mactrack_device_type_id", "-1");
	load_current_session_value("device_type_id", "sess_mactrack_device_device_type_id", "-1");
	load_current_session_value("status", "sess_mactrack_device_status", "-1");
	load_current_session_value("sort_column", "sess_mactrack_device_sort_column", "site_name");
	load_current_session_value("sort_direction", "sess_mactrack_device_sort_direction", "ASC");

	html_start_box("<strong>Mac Track Device Filters</strong>", "98%", $colors["header"], "3", "center", "mactrack_devices.php?action=edit&status=" . $_REQUEST["status"]);

	include("plugins/mactrack/html/inc_mactrack_device_filter_table.php");

	html_end_box();

	$sql_where = "";

	$devices = mactrack_get_devices($sql_where);

	$total_rows = db_fetch_cell("SELECT
		COUNT(mac_track_devices.device_id)
		FROM mac_track_sites
		RIGHT JOIN mac_track_devices ON mac_track_devices.site_id = mac_track_sites.site_id
		$sql_where");

	html_start_box("", "98%", $colors["header"], "3", "center", "");

	/* generate page list */
	$url_page_select = get_page_list($_REQUEST["page"], MAX_DISPLAY_PAGES, read_config_option("num_rows_mactrack"), $total_rows, "mactrack_devices.php?filter=" . $_REQUEST["filter"] . "&site_id=" . $_REQUEST["site_id"] . "&status=" . $_REQUEST["status"]);

	$nav = "<tr bgcolor='#" . $colors["header"] . "'>
			<td colspan='12'>
				<table width='100%' cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td align='left' class='textHeaderDark'>
							<strong>&lt;&lt; "; if ($_REQUEST["page"] > 1) { $nav .= "<a class='linkOverDark' href='mactrack_devices.php?filter=" . $_REQUEST["filter"] . "&site_id=" . $_REQUEST["site_id"] . "&status=" . $_REQUEST["status"] . "&page=" . ($_REQUEST["page"]-1) . "'>"; } $nav .= "Previous"; if ($_REQUEST["page"] > 1) { $nav .= "</a>"; } $nav .= "</strong>
						</td>\n
						<td align='center' class='textHeaderDark'>
							Showing Rows " . ((read_config_option("num_rows_mactrack")*($_REQUEST["page"]-1))+1) . " to " . ((($total_rows < read_config_option("num_rows_mactrack")) || ($total_rows < (read_config_option("num_rows_mactrack")*$_REQUEST["page"]))) ? $total_rows : (read_config_option("num_rows_mactrack")*$_REQUEST["page"])) . " of $total_rows [$url_page_select]
						</td>\n
						<td align='right' class='textHeaderDark'>
							<strong>"; if (($_REQUEST["page"] * read_config_option("num_rows_mactrack")) < $total_rows) { $nav .= "<a class='linkOverDark' href='mactrack_devices.php?filter=" . $_REQUEST["filter"] . "&site_id=" . $_REQUEST["site_id"] . "&status=" . $_REQUEST["status"] . "&page=" . ($_REQUEST["page"]+1) . "'>"; } $nav .= "Next"; if (($_REQUEST["page"] * read_config_option("num_rows_mactrack")) < $total_rows) { $nav .= "</a>"; } $nav .= " &gt;&gt;</strong>
						</td>\n
					</tr>
				</table>
			</td>
		</tr>\n";

	print $nav;

	$display_text = array(
		"description" => array("Host<br>Description", "ASC"),
		"site_name" => array("<br>Site Name", "ASC"),
		"snmp_status" => array("<br>Status", "ASC"),
		"hostname" => array("<br>Hostname", "ASC"),
		"scan_type" => array("Device<br>Type", "ASC"),
		"ips_total" => array("Total<br>IP's", "DESC"),
		"ports_total" => array("User<br>Ports", "DESC"),
		"ports_active" => array("User<br>Ports Up", "DESC"),
		"ports_trunk" => array("Trunk<br>Ports", "DESC"),
		"macs_active" => array("Active<br>Macs", "DESC"),
		"last_runduration" => array("Last<br>Duration", "DESC"));

	html_header_sort_checkbox($display_text, $_REQUEST["sort_column"], $_REQUEST["sort_direction"]);

	$i = 0;
	if (sizeof($devices) > 0) {
		foreach ($devices as $device) {
			form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
				?>
				<td width=100>
					<a class="linkEditMain" href="mactrack_devices.php?action=edit&device_id=<?php print $device["device_id"];?>"><?php print eregi_replace("(" . preg_quote($_REQUEST["filter"]) . ")", "<span style='background-color: #F8D93D;'>\\1</span>", $device["description"]);?></a>
				</td>
				<td><?php print $device["site_name"];?></td>
				<td><?php print get_colored_device_status(($device["disabled"] == "on" ? true : false), $device["snmp_status"]);?></td>
				<td><?php print eregi_replace("(" . preg_quote($_REQUEST["filter"]) . ")", "<span style='background-color: #F8D93D;'>\\1</span>", $device["hostname"]);?></td>
				<td><?php print $mactrack_device_types[$device["scan_type"]];?></td>
				<td><?php print ($device["scan_type"] == "1" ? "N/A" : $device["ips_total"]);?></td>
				<td><?php print ($device["scan_type"] == "3" ? "N/A" : $device["ports_total"]);?></td>
				<td><?php print ($device["scan_type"] == "3" ? "N/A" : $device["ports_active"]);?></td>
				<td><?php print ($device["scan_type"] == "3" ? "N/A" : $device["ports_trunk"]);?></td>
				<td><?php print ($device["scan_type"] == "3" ? "N/A" : $device["macs_active"]);?></td>
				<td><?php print number_format($device["last_runduration"], 1);?></td>
				<td style="<?php print get_checkbox_style();?>" width="1%" align="right">
					<input type='checkbox' style='margin: 0px;' name='chk_<?php print $device["device_id"];?>' title="<?php print $device["description"];?>">
				</td>
			</tr>
			<?php
		}

		/* put the nav bar on the bottom as well */
		print $nav;
	}else{
		print "<tr><td><em>No Mac Track Devices</em></td></tr>";
	}
	html_end_box(false);

	/* draw the dropdown containing a list of available actions for this form */
	draw_actions_dropdown($device_actions);
}

?>